FLASHROM(8)

NAME
flashrom - detect, read, write, verify and erase flash chips

SYNOPSIS
flashrom [-VfLzhRn] [-E|-r file|-w file|-v file] [-c chipname]
         [-m [vendor:]part] [-l file] [-i image] [-p programmer]

DESCRIPTION
flashrom is a utility for detecting, reading, writing, verifying and erasing flash chips. It's often used to flash BIOS/EFI/coreboot/firmware images in-system using a supported mainboard, but it also supports flashing of network cards (NICs), SATA controller cards, and other external devices which can program flash chips.

It supports a wide range of DIP32, PLCC32, DIP8, SO8/SOIC8, TSOP32, and TSOP40 chips, which use various protocols such as LPC, FWH, parallel flash, or SPI.

OPTIONS
Please note that the command line interface for flashrom will change before flashrom 1.0. Do not use flashrom in scripts or other automated tools without checking that your flashrom version won't interpret options in a different way.

You can specify one of -E, -r, -w, -v or no operation. If no operation is specified, then all that happens is that flash info is dumped and the flash chip is set to writable.

-r, --read <file>
    Read flash ROM contents and save them into the given <file>.

-w, --write <file>
    Write file into flash ROM.

-n, --noverify
    Do not verify the flash ROM contents after writing them to the chip. Using this option is not recommended, you should only use it if you know what you are doing and you feel that the time for verification takes too long.

    Typical usage is: flashrom -wn file

    This option is only useful in combination with --write.

-v, --verify <file>
    Verify the flash ROM contents against the given <file>.

-E, --erase
    Erase the flash ROM chip.

-V, --verbose
    More verbose output.

-c, --chip <chipname>
    Probe only for specified flash ROM chip.

    flashrom supports ROM layouts. This allows you to flash certain parts of the flash chip only. A ROM layout file looks like follows:

      00000000:00008fff gfxrom
      00009000:0003ffff normal
      00040000:0007ffff fallback

      i.e.:
      startaddr:endaddr name

    All addresses are offsets within the file, not absolute addresses! If you only want to update the normal image in a ROM you can say:

    flashrom -w --layout rom.layout --image normal agami_aruma.rom

    To update normal and fallback but leave the VGA BIOS alone, say:

    flashrom -w -l rom.layout -i normal
    -i fallback agami_aruma.rom

    Currently overlapping sections are not supported.

    ROM layouts should replace the -s and -e option since they are more flexible and they should lead to a ROM update file format with the ROM layout and the ROM image in one file (cpio, zip or something?).

-m, --mainboard <[vendor:]part>
    Override mainboard settings.

    flashrom reads the coreboot table to determine the current mainboard. If no coreboot table could be read or if you want to override these values, you can specify -m, e.g.:

    flashrom -w --mainboard AGAMI:ARUMA agami_aruma.rom

    See the 'Supported mainboards' section in the output of 'flashrom -L' for a list of boards which require the specification of the board name, if no coreboot table is found.

-f, --force
    Force write without checking whether the ROM image file is really meant to be used on this board.

    Note: This check only works while coreboot is running, and only for those boards where the coreboot code supports it.

-l, --layout <file>
    Read ROM layout from <file>.

-i, --image <name>
    Only flash image <name> from flash layout.

-L, --list-supported
    List the flash chips, chipsets, mainboards, and PCI card "programmers" supported by flashrom.

    There are many unlisted boards which will work out of the box, without special support in flashrom. Please let us know if you can verify that other boards work or do not work out of the box. For verification you have to test an ERASE and/or WRITE operation, so make sure you only do that if you have proper means to recover from failure!

-z, --list-supported-wiki
    Same as --list-supported, but outputs the supported hardware in MediaWiki syntax, so that it can be easily pasted into the wiki page at http://www.flashrom.org/.

-p, --programmer <name>
    Specify the programmer device. Currently supported are:

    * internal (default, for in-system flashing in the mainboard)

    * dummy (just prints all operations and accesses)

    * nic3com (for flash ROMs on 3COM network cards)

    * satasii (for flash ROMs on Silicon Image SATA/IDE controllers)

    * it87spi (for flash ROMs behind an ITE IT87xx Super I/O LPC/SPI translation unit)

    * ft2232spi (for flash ROMs attached to a FT2232H/FT4232H based USB SPI programmer)

    * serprog (for flash ROMs attached to Urja's AVR programmer)

    The dummy programmer has an optional parameter specifying the bus types it should support. For that you have to use the flashrom -p dummy:type syntax where type can be any comma-separated combination of parallel lpc fwh spi all in any order.

    Example: flashrom -p dummy:lpc,fwh

    If you have multiple supported PCI cards which can program flash chips (NICs, SATA/IDE controllers, etc.) in your system, you must use the flashrom -p xxxx:bb:dd.f syntax to explicitly select one of them, where xxxx is the name of the programmer bb is the PCI bus number, dd is the PCI device number, and f is the PCI function number of the desired NIC.

    Example: flashrom -p nic3com:05:04.0

    Currently the following programmers support this mechanism: nic3com, satasii.

    The it87spi programmer has an optional parameter which will set the I/O base port of the IT87* SPI controller interface to the port specified in the parameter. For that you have to use the flashrom -p it87spi:port=portnum syntax where portnum is an I/O port number which must be a multiple of 8.

    The ft2232spi programmer has an optional parameter specifying the controller type and interface/port it should support. For that you have to use the flashrom -p ft2232spi:model,port=interface syntax where model can be any of 2232H 4232H and interface can be any of A B. The default model is 4232H and the default interface is B.

    The serprog programmer has an optional parameter specifying either a serial device/baud combination or an IP/port combination for communication with the programmer. For serial, you have to use the flashrom -p serprog:/dev/device:baud syntax and for IP, you have to use flashrom -p serprog:ip:port instead. More information about serprog is available in serprog-protocol.txt in the source distribution.

    Support for some programmers can be disabled at compile time. flashrom -h lists all supported programmers.

-h, --help
    Show a help text and exit.

-R, --version
    Show version information and exit.

EXIT STATUS
flashrom exits with 0 on success, 1 on most failures but with 2 if /dev/mem (/dev/xsvc on Solaris) can not be opened and with 3 if a call to mmap() fails.

BUGS
Please report any bugs at http://www.flashrom.org/trac/flashrom/newticket, or on the flashrom mailing list (http://www.flashrom.org/mailman/listinfo/flashrom).

LICENCE
flashrom is covered by the GNU General Public License (GPL), version 2. Some files are additionally available under the GPL (version 2, or any later version).

COPYRIGHT
Please see the individual files.

AUTHORS
Carl-Daniel Hailfinger
Claus Gindhart <claus.gindhart@kontron.com>
Dominik Geyer <dominik.geyer@kontron.com>
Eric Biederman <ebiederman@lnxi.com>
Giampiero Giancipoli <gianci@email.it>
Joe Bao <Zheng.Bao@amd.com>
Luc Verhaegen <libv@skynet.be>
Li-Ta Lo
Markus Boas <ryven@ryven.de>
Nikolay Petukhov <nikolay.petukhov@gmail.com>
Peter Stuge <peter@stuge.se>
Reinder E.N. de Haan <lb_reha@mveas.com>
Ronald G. Minnich <rminnich@gmail.com>
Ronald Hoogenboom <ronald@zonnet.nl>
Stefan Reinauer <stepan@coresystems.de>
Stefan Wildemann <stefan.wildemann@kontron.com>
Steven James <pyro@linuxlabs.com>
Uwe Hermann <uwe@hermann-uwe.de>
Wang Qingpei <Qingpei.Wang@amd.com>
Yinghai Lu <yinghai.lu@amd.com>
some others

This manual page was written by Uwe Hermann <uwe@hermann-uwe.de>. It is licensed under the terms of the GNU GPL (version 2 or later).